/*
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2001 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/sauge/code/progress/ezine34/RCS/StoreFile.p,v 1.1 2003/07/21 08:23:05 sauge Exp sauge $" NO-UNDO.

DEF INPUT PARAMETER cFileName    AS CHARACTER NO-UNDO.
DEF INPUT PARAMETER cDirectory   AS CHARACTER NO-UNDO.
DEF INPUT PARAMETER cContentType AS CHARACTER NO-UNDO.
DEF OUTPUT PARAMETER cOSFileID   AS CHARACTER NO-UNDO.
DEF OUTPUT PARAMETER cError      AS CHARACTER NO-UNDO.

DEF VAR rData AS RAW NO-UNDO.
DEF VAR iSequence    AS INTEGER NO-UNDO INITIAL 1.

{Error.i}
{LastStringCharacter.i}
{MakeID3.i}

/* Best to make this the size of a database block. */

ASSIGN LENGTH(rData) = 16384.

/* Make sure the directory has a delimiter on it. */

IF LastStringCharacter(cDirectory) <> "/" THEN 
  ASSIGN cDirectory = cDirectory + "/".

/* Make the header, then load in the data into multiple records if */
/* we hit past the max record size.                                */

CREATE OSFile.

ASSIGN OSFile.OSFileID = MakeID3(10).

ASSIGN 
OSFile.FileName = cFileName
OSFile.OSFileType = cContentType
OSFile.CreateDate = TODAY
OSFile.CreateTime = TIME.

/* Load into the Data table for a OSFile. */

INPUT FROM VALUE(cDirectory + cFileName) BINARY NO-MAP NO-CONVERT.

REPEAT:

    IMPORT UNFORMATTED rData.

    CREATE OSFileData.

    ASSIGN OSFileData.OSFileID = OSFile.OSFileID.

    ASSIGN OSFileData.Sequence = iSequence
           OSFileData.Data     = rData

           iSequence           = iSequence + 1.

END. /* REPEAT */

INPUT CLOSE.

/* OS-DELETE VALUE(cDirectory + cFileName). */

ASSIGN cOSFileID = OSFile.OSFileID
       cError = {&NOERROR}.

