/*
 * Removal of this header is illegal.
 * Written by Scott Auge scott_auge@yahoo.com sauge@amduus.com
 * Copyright (c) 2002 Amduus Information Works, Inc.  www.amduus.com
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Amduus Information Works
 *      Inc. and its contributors.
 * 4. Neither the name of Amduus Information Works, Inc. nor the names of 
 *    its contributors may be used to endorse or promote products derived 
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY AMDUUS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AMDUUS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

DEF VAR RCSVersion AS CHARACTER INIT "$Header: /home/sauge/code/progress/ezine34/RCS/WalkLoadDir.p,v 1.1 2003/07/21 08:23:05 sauge Exp sauge $" NO-UNDO. 

DEF INPUT PARAMETER cBaseDirectory     AS CHARACTER NO-UNDO.
DEF INPUT PARAMETER cWorkingDirectory  AS CHARACTER NO-UNDO.
DEF INPUT PARAMETER cXUpgradeOSFileID  AS CHARACTER NO-UNDO.

DEF VAR cDirList        AS CHARACTER NO-UNDO.
DEF VAR cFileList       AS CHARACTER NO-UNDO.

DEF VAR iDirListCnt     AS INTEGER NO-UNDO.
DEF VAR iDirListIdx     AS INTEGER NO-UNDO.

DEF VAR iFileListCnt    AS INTEGER NO-UNDO.
DEF VAR iFileListIdx    AS INTEGER NO-UNDO.

DEF VAR cSubDir         AS CHARACTER NO-UNDO.
DEF VAR cOldWorkingDirectory AS CHARACTER NO-UNDO.

DEF VAR cOSFileID       AS CHARACTER NO-UNDO.
DEF VAR cError          AS CHARACTER NO-UNDO.

DEF VAR cDelimiter      AS CHARACTER NO-UNDO.

ASSIGN cDelimiter = CHR(250).

MESSAGE "Working Directory: " cWorkingDirectory.

/* Load up the directories and files available in the working directory */

RUN ReadDirectory.p (INPUT cWorkingDirectory,
                     OUTPUT cDirList,
                     OUTPUT cFileList).

ASSIGN iDirListCnt = NUM-ENTRIES(cDirList, cDelimiter).
ASSIGN iFileListCnt = NUM-ENTRIES(cFileList, cDelimiter).

/* Load up the files into the database using WorkingDirectory -    */
/* BaseDirectory to as part of the file name (assume BaseDirectory */
/* is part of the PROPATH.                                         */

cSubDir = REPLACE(cWorkingDirectory, cBaseDirectory, "").

DO iFileListIdx = 1 TO iFileListCnt:

  RUN StoreFile.p (INPUT cSubDir + ENTRY(iFileListIdx, cFileList, cDelimiter),
                         cBaseDirectory,
                         "",
                         OUTPUT cOSFileID,
                         OUTPUT cError).

  CREATE XUpgradeOSFileList.

  ASSIGN
  XUpgradeOSFileList.OSFileID = cOSFileID
  XUpgradeOSFileList.XUpgradeOSFileID = cXUpgradeOSFileID.

END. /* DO iFileListIdx = 1 TO iFileListCnt */

/* Walk into the directories available here and load up those files */
ASSIGN cOldWorkingDirectory = cWorkingDirectory.
DO iDirListIdx = 1 TO iDirListCnt:

  ASSIGN cWorkingDirectory = cOldWorkingDirectory
                           + ENTRY(iDirListIdx, cDirList, cDelimiter)
                           + "/".

  RUN WalkLoadDir.p
  (INPUT cBaseDirectory,
   INPUT cWorkingDirectory,
   INPUT cXUpgradeOSFileID).

END. /* DO iDirListIdx = 1 TO iDirListCnt */


